Plugin.extend({
    target: '',
    buttonSounds: [],
    buttons: [],
    _testis: undefined,
    _type: 'keyboard',
    _isContainer: false,
    _render: true,
    //_input:"",
    initPlugin: function(data) {
        var dims = this.relativeDims();
        var div = document.getElementById(data.id);
        var asset = data.asset;
        if (div) {
            jQuery("#" + data.id).remove();
        }

        var cols = 12;
        var rows = 1;

        if (data.cols) {
            cols = data.cols;
        }

        div = document.createElement('div');
        target = data.target;
        var customButtons;

        if (data.keys) {
            customButtons = this._stage.getModelValue(data.keys);
        }

        if (data.type == "custom") {
            customButtons = customButtons.replace(/ /g, '');
            var buttonsAre = customButtons.split(',');
            buttons = buttonsAre.splice(0, 36);
           
            rows = Math.ceil(buttons.length / cols);
            var keyHeight = dims.h / rows;
            var keyWidth = dims.w / cols;

            div.id = "keyboardBarakhadi";
            div.style.top = dims.y + "px"; //data.y+"%";
            div.style.left = dims.x + "px"; //data.x+"%";
            div.style.width = dims.w + "px";
            div.style.height = dims.h + "px";
            if (buttons.length <= cols) {
                keyHeight = dims.h / 2.5 * rows;
            }
            var fontSize = 3.0; 

            div.innerHTML = '';
            console.log("dimsx " + dims.x + " dimsy " + dims.y + " fontsize " + fontSize);
            console.log(dims);
            var customKeys = '';
            for (var i = 0; i < buttons.length; i++) {
                if (i % 12 == 0) {
                    customKeys += '<div class="key_barakhadi firstkey" style="width: ' + keyWidth + 'px; height:' + keyHeight + 'px; font-size:' + fontSize + 'vw;" id="' + buttons[i] + '_btn"><span class="test">' + buttons[i] + '</span></div>';
                } else {
                    customKeys += '<div class="key_barakhadi" style="width: ' + keyWidth + 'px; height:' + keyHeight + 'px; font-size:' + fontSize + 'vw;" id="' + buttons[i] + '_btn"><span class="test">' + buttons[i] + '</span></div>';
                }
            }
            div.innerHTML = '' + customKeys + '';
        }

        var parentDiv = document.getElementById(Renderer.divIds.gameArea);
        parentDiv.insertBefore(div, parentDiv.childNodes[0]);

        for (var i = buttons.length - 1; i >= 0; i--) {
            this.assignButtonEvent(buttons[i], asset, data.limit);
        };
        this._self = new createjs.DOMElement(div);
    },
    switchTarget: function(action) {
        target = action.id;
    },
    assignButtonEvent: function(id, asset, limit) {
        var btn = document.getElementById(id + '_btn');
        var instance = this;
        if (btn != null) {
            btn.addEventListener("click", function() {
                var newText = PluginManager.getPluginObject(target);
                if (newText._self.text.length + id.length <= limit) {
                    newText._self.text += id;
                }
                Renderer.update = true;
                instance._stage.setModelValue(newText._data.model, newText._self.text)
            });
        }
    }
});
